(
//@ sd fbDelay
SynthDef(\fbDelay, {|out=0, in=10, feedback=0.5, delayTime=0.5|
	var sig = In.ar(in, 2);
	sig = FbC({|fb| fb * feedback + sig}, 2, delayTime) + sig;
	Out.ar(out, sig);
}).add;



//@ sd kick
SynthDef(\kick, {|out=0, freq=60, amp=0.1, pan=0|
	
	var sig = SinOsc.ar(XLine.kr(freq*4, freq, 0.05), phase:0.5pi);
	var env = EnvGen.ar(Env.perc(0.0001,0.1), doneAction:2);
	sig = Pan2.ar(sig, pan) * env;
	
	sig = (sig * 2).softclip;
	
	OffsetOut.ar(out, sig * amp);
}).add;



//@ sd hat
SynthDef(\hat, {|out=0, freq=2000, amp=0.1, pan=0, len=1, delayBus=10, delay=0|
	
	var sig = RHPF.ar(WhiteNoise.ar, XLine.kr(freq*4, freq, 0.01*len), 0.7);
	var env = EnvGen.ar(Env.perc(0.001, 0.01 * len), doneAction:2);
	sig = Pan2.ar(sig, pan) * env;
	
	OffsetOut.ar(out, sig * amp * 0.8);
	OffsetOut.ar(delayBus, sig * amp * delay);

}).add;



//@ sd snare
SynthDef(\snare, {|out=0, freq=440, amp=0.1, pan=0|
	
	var sig = RLPF.ar(WhiteNoise.ar(), XLine.kr(15000, 4000, 0.2));
	var env = EnvGen.ar(Env.perc(0.01,0.06), doneAction:2);
	sig = Pan2.ar(sig, pan) * env;
	
	sig = (sig * 2.5).softclip;
	
	OffsetOut.ar(out, sig * amp);
}).add;



//@ sd pling
SynthDef(\pling, {|out=0, freq=440, amp=0.1, pan=0, att=0.001, dec=0.1, delayBus=10, delay=0|
	
	var sig = SinOsc.ar(freq) * SinOsc.ar(Rand(2), phase:0.5pi);
	var env = EnvGen.ar(Env.perc(att, dec), doneAction:2);
	sig = Pan2.ar(sig, pan) * env;
	
	OffsetOut.ar(out, sig * amp);
	OffsetOut.ar(delayBus, sig * amp * delay);
}).add;



 //@ sd bass
SynthDef(\bass, {|out=0, freq=440, amp=0.1, pan=0|
	
	var sig = Mix.ar(Saw.ar(freq * [1, 1.01, 3])) / 3;
	var env = EnvGen.ar(Env.perc(0.01,0.4), doneAction:2);
	sig = RLPF.ar(sig, XLine.kr(4000, 100, 0.2), 0.9);
	sig = Pan2.ar(sig, pan) * env;
	
	sig = (sig * 3).softclip;
	
	OffsetOut.ar(out, sig * amp);
}).add;

)