import liblo

class Server:
    def __init__(self, host, port):
        self.last_synth_id = 1000
        
        self.address = liblo.Address(host, port)
    
    def next_synth_id(self):
        self.last_synth_id += 1
        return self.last_synth_id
        
    def send(self, msg):
        liblo.send(self.address, msg)

class Synth:
    def __init__(self, server, synthdef, addAction, args):
        self.server = server
        
        self.id = server.next_synth_id()
        
        msg = liblo.Message("/s_new", synthdef, self.id, addAction, 0)
        for key in args:
            msg.add(key, args[key])
        
        self.server.send(msg)
        
    def set(self, key, value):
        self.server.send(liblo.Message("/n_set", self.id, key, value))
        
    def end(self):
        self.server.send(liblo.Message("/n_free", self.id))


class GatedSynth(Synth):
    def end(self):
        self.set("gate", 0)